package b4a.example;

import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	public static final boolean fullScreen = false;
	public static final boolean includeTitle = true;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "b4a.example", "b4a.example.main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
            
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                BA.LogInfo("Killing previous instance (main).");
				p.finish();
			}
		}
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
		BA.handler.postDelayed(new WaitForLayout(), 5);

	}
	private static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
            
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "b4a.example", "b4a.example.main");
        
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (BA.isShellModeRuntimeCheck(processBA)) {
			if (isFirst)
				processBA.raiseEvent2(null, true, "SHELL", false);
			processBA.raiseEvent2(null, true, "CREATE", true, "b4a.example.main", processBA, activityBA, _activity, anywheresoftware.b4a.keywords.Common.Density);
			_activity.reinitializeForShell(activityBA, "activity");
		}
        initializeProcessGlobals();		
        initializeGlobals();
        
        BA.LogInfo("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        BA.LogInfo("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
		return true;
	}
    public void onWindowFocusChanged(boolean hasFocus) {
       super.onWindowFocusChanged(hasFocus);
       if (processBA.subExists("activity_windowfocuschanged"))
           processBA.raiseEvent2(null, true, "activity_windowfocuschanged", false, hasFocus);
    }
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK &&
					android.os.Build.VERSION.SDK_INT >= 18) {
				HandleKeyDelayed hk = new HandleKeyDelayed();
				hk.kc = keyCode;
				BA.handler.post(hk);
				return true;
			}
			else {
				boolean res = new HandleKeyDelayed().runDirectly(keyCode);
				if (res)
					return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
	private class HandleKeyDelayed implements Runnable {
		int kc;
		public void run() {
			runDirectly(kc);
		}
		public boolean runDirectly(int keyCode) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true) {
                return true;
            }
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
            return false;
		}
		
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
		this.setIntent(intent);
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        BA.LogInfo("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            BA.LogInfo("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}

public anywheresoftware.b4a.keywords.Common __c = null;
public static anywheresoftware.b4a.objects.collections.Map _cfggeneral = null;
public static String _s = "";
public static int _i = 0;
public static long _l = 0L;
public static boolean _b = false;
  public Object[] GetGlobals() {
		return new Object[] {"Activity",mostCurrent._activity,"B",_b,"cfgGeneral",_cfggeneral,"I",_i,"L",_l,"S",_s};
}

public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
return vis;}

public static void killProgram() {
     {
            Activity __a = null;
            if (main.previousOne != null) {
				__a = main.previousOne.get();
			}
            else {
                BA ba = main.mostCurrent.processBA.sharedProcessBA.activityBA.get();
                if (ba != null) __a = ba.activity;
            }
            if (__a != null)
				__a.finish();}

}
public static String  _activity_create(boolean _firsttime) throws Exception{
		Debug.PushSubsStack("Activity_Create (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
Debug.locals.put("FirstTime", _firsttime);
 BA.debugLineNum = 31;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
Debug.ShouldStop(1073741824);
 BA.debugLineNum = 34;BA.debugLine="If FirstTime Then";
Debug.ShouldStop(2);
if (_firsttime) { 
 BA.debugLineNum = 35;BA.debugLine="If File.Exists(File.DirInternal,\"myconfig.cfg\") Then";
Debug.ShouldStop(4);
if (anywheresoftware.b4a.keywords.Common.File.Exists(anywheresoftware.b4a.keywords.Common.File.getDirInternal(),"myconfig.cfg")) { 
 BA.debugLineNum = 36;BA.debugLine="cfgGeneral = File.ReadMap(File.DirInternal,\"myconfig.cfg\")";
Debug.ShouldStop(8);
_cfggeneral = anywheresoftware.b4a.keywords.Common.File.ReadMap(anywheresoftware.b4a.keywords.Common.File.getDirInternal(),"myconfig.cfg");
 BA.debugLineNum = 37;BA.debugLine="Log(\"map size =\" & cfgGeneral.Size)";
Debug.ShouldStop(16);
anywheresoftware.b4a.keywords.Common.Log("map size ="+BA.NumberToString(_cfggeneral.getSize()));
 }else {
 BA.debugLineNum = 39;BA.debugLine="cfgGeneral.Initialize";
Debug.ShouldStop(64);
_cfggeneral.Initialize();
 };
 BA.debugLineNum = 41;BA.debugLine="S = cfgGeneral.GetDefault(\"string\",\"\")";
Debug.ShouldStop(256);
_s = BA.ObjectToString(_cfggeneral.GetDefault((Object)("string"),(Object)("")));
 BA.debugLineNum = 42;BA.debugLine="I = cfgGeneral.GetDefault(\"integer\",0)";
Debug.ShouldStop(512);
_i = (int)(BA.ObjectToNumber(_cfggeneral.GetDefault((Object)("integer"),(Object)(0))));
 BA.debugLineNum = 43;BA.debugLine="L = cfgGeneral.GetDefault(\"long\",0)";
Debug.ShouldStop(1024);
_l = BA.ObjectToLongNumber(_cfggeneral.GetDefault((Object)("long"),(Object)(0)));
 BA.debugLineNum = 44;BA.debugLine="B = cfgGeneral.GetDefault(\"bool\",False)";
Debug.ShouldStop(2048);
_b = BA.ObjectToBoolean(_cfggeneral.GetDefault((Object)("bool"),(Object)(anywheresoftware.b4a.keywords.Common.False)));
 BA.debugLineNum = 45;BA.debugLine="cfgGeneral.Put(\"string\",S)";
Debug.ShouldStop(4096);
_cfggeneral.Put((Object)("string"),(Object)(_s));
 BA.debugLineNum = 46;BA.debugLine="cfgGeneral.Put(\"integer\",I)";
Debug.ShouldStop(8192);
_cfggeneral.Put((Object)("integer"),(Object)(_i));
 BA.debugLineNum = 47;BA.debugLine="cfgGeneral.Put(\"long\",L)";
Debug.ShouldStop(16384);
_cfggeneral.Put((Object)("long"),(Object)(_l));
 BA.debugLineNum = 48;BA.debugLine="cfgGeneral.Put(\"bool\",B)";
Debug.ShouldStop(32768);
_cfggeneral.Put((Object)("bool"),(Object)(_b));
 BA.debugLineNum = 49;BA.debugLine="File.WriteMap(File.DirInternal,\"myconfig.cfg\",cfgGeneral)";
Debug.ShouldStop(65536);
anywheresoftware.b4a.keywords.Common.File.WriteMap(anywheresoftware.b4a.keywords.Common.File.getDirInternal(),"myconfig.cfg",_cfggeneral);
 };
 BA.debugLineNum = 51;BA.debugLine="End Sub";
Debug.ShouldStop(262144);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _activity_pause(boolean _userclosed) throws Exception{
		Debug.PushSubsStack("Activity_Pause (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
Debug.locals.put("UserClosed", _userclosed);
 BA.debugLineNum = 60;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
Debug.ShouldStop(134217728);
 BA.debugLineNum = 61;BA.debugLine="cfgGeneral.Put(\"string\",S)";
Debug.ShouldStop(268435456);
_cfggeneral.Put((Object)("string"),(Object)(_s));
 BA.debugLineNum = 62;BA.debugLine="cfgGeneral.Put(\"integer\",I)";
Debug.ShouldStop(536870912);
_cfggeneral.Put((Object)("integer"),(Object)(_i));
 BA.debugLineNum = 63;BA.debugLine="cfgGeneral.Put(\"long\",L)";
Debug.ShouldStop(1073741824);
_cfggeneral.Put((Object)("long"),(Object)(_l));
 BA.debugLineNum = 64;BA.debugLine="cfgGeneral.Put(\"bool\",B)";
Debug.ShouldStop(-2147483648);
_cfggeneral.Put((Object)("bool"),(Object)(_b));
 BA.debugLineNum = 65;BA.debugLine="File.WriteMap(File.DirInternal,\"myconfig.cfg\",cfgGeneral)";
Debug.ShouldStop(1);
anywheresoftware.b4a.keywords.Common.File.WriteMap(anywheresoftware.b4a.keywords.Common.File.getDirInternal(),"myconfig.cfg",_cfggeneral);
 BA.debugLineNum = 66;BA.debugLine="End Sub";
Debug.ShouldStop(2);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _activity_resume() throws Exception{
		Debug.PushSubsStack("Activity_Resume (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
 BA.debugLineNum = 53;BA.debugLine="Sub Activity_Resume";
Debug.ShouldStop(1048576);
 BA.debugLineNum = 54;BA.debugLine="S = cfgGeneral.GetDefault(\"string\",\"\")";
Debug.ShouldStop(2097152);
_s = BA.ObjectToString(_cfggeneral.GetDefault((Object)("string"),(Object)("")));
 BA.debugLineNum = 55;BA.debugLine="I = cfgGeneral.GetDefault(\"integer\",0)";
Debug.ShouldStop(4194304);
_i = (int)(BA.ObjectToNumber(_cfggeneral.GetDefault((Object)("integer"),(Object)(0))));
 BA.debugLineNum = 56;BA.debugLine="L = cfgGeneral.GetDefault(\"long\",0)";
Debug.ShouldStop(8388608);
_l = BA.ObjectToLongNumber(_cfggeneral.GetDefault((Object)("long"),(Object)(0)));
 BA.debugLineNum = 57;BA.debugLine="B = cfgGeneral.GetDefault(\"bool\",False)";
Debug.ShouldStop(16777216);
_b = BA.ObjectToBoolean(_cfggeneral.GetDefault((Object)("bool"),(Object)(anywheresoftware.b4a.keywords.Common.False)));
 BA.debugLineNum = 58;BA.debugLine="End Sub";
Debug.ShouldStop(33554432);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}

public static void initializeProcessGlobals() {
    if (mostCurrent != null && mostCurrent.activityBA != null) {
Debug.StartDebugging(mostCurrent.activityBA, 14321, new int[] {3}, "6de35cc6-e17b-48c9-888e-3960900772b2");}

    if (main.processGlobalsRun == false) {
	    main.processGlobalsRun = true;
		try {
		        main._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}public static String  _globals() throws Exception{
 //BA.debugLineNum = 25;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 29;BA.debugLine="End Sub";
return "";
}
public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 15;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 18;BA.debugLine="Dim cfgGeneral As Map";
_cfggeneral = new anywheresoftware.b4a.objects.collections.Map();
 //BA.debugLineNum = 19;BA.debugLine="Dim S As String : S = \"Something\"";
_s = "";
 //BA.debugLineNum = 19;BA.debugLine="Dim S As String : S = \"Something\"";
_s = "Something";
 //BA.debugLineNum = 20;BA.debugLine="Dim I As Int : I = 12345";
_i = 0;
 //BA.debugLineNum = 20;BA.debugLine="Dim I As Int : I = 12345";
_i = (int) (12345);
 //BA.debugLineNum = 21;BA.debugLine="Dim L As Long: L = 123456789";
_l = 0L;
 //BA.debugLineNum = 21;BA.debugLine="Dim L As Long: L = 123456789";
_l = (long) (123456789);
 //BA.debugLineNum = 22;BA.debugLine="Dim B As Boolean : B = True";
_b = false;
 //BA.debugLineNum = 22;BA.debugLine="Dim B As Boolean : B = True";
_b = anywheresoftware.b4a.keywords.Common.True;
 //BA.debugLineNum = 23;BA.debugLine="End Sub";
return "";
}
}
